import { classes } from '@automapper/classes';
import { AutomapperModule } from '@automapper/nestjs';
import { Test, TestingModule } from '@nestjs/testing';
import { ValidateAuthorizationRequest } from '../../domain/dtos/validate-authorization.request';
import { ValidateAuthorizationUseCase } from '../../domain/usecases/validate-authorization.usecase';

describe('ValidateAuthorizationUseCase', () => {
  let validateAuthorizationUseCase: ValidateAuthorizationUseCase;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [AutomapperModule.forRoot({ strategyInitializer: classes() })],
      providers: [ValidateAuthorizationUseCase],
    }).compile();

    validateAuthorizationUseCase = module.get<ValidateAuthorizationUseCase>(
      ValidateAuthorizationUseCase,
    );
  });

  it('should be defined', () => {
    expect(validateAuthorizationUseCase).toBeDefined();
  });

  describe('execute', () => {
    it('should validate an authorization', async () => {
      const validateAuthorizationRequest: ValidateAuthorizationRequest =
        new ValidateAuthorizationRequest();
      validateAuthorizationRequest.uuid =
        'bb281075-1b98-4456-89d6-c643d3044a91';
      validateAuthorizationRequest.action = 'authorized';

      expect(
        validateAuthorizationUseCase.execute(validateAuthorizationRequest),
      ).toBeTruthy();
    });
  });
});
